new;
library coint, pgraph;
output file=fmgive.out reset;

load rn[100, 10]=rn.dat;

// Generate random walks
d = ones(100, 1);
dx = rn[., 1:2];
dz = rn[., 5:8];
e2 = rn[., 3];
e1 = rn[., 4];          

// Accumulate the innovations
x = recserar(dx, 0.0~0.0, 1.0~1.0);

/* 
** x is a non-cointegrated system
** of 2 I(1) variables            
*/

z = recserar(dz, 0.0~0.0~0.0~0.0, 1.0~1.0~1.0~1.0);

/* 
** develop a cointegrated regression equation
** cointegrating vector: (1,-1,-1)            
*/

_times = 10;
_filter = 0;
_aband = 0;

y1  = 0.2*x[., 1] + 0.5*x[., 2] + e1;
y2  = 0.5*x[., 1] + 0.1*x[., 2] + e2;

_ker_fun = &parzen;

// Estimate using FM-GMM

"system of two equations, two explanatory variables";
{ ahat, vc, lrv, s1, s2 } = fm_give(y1~y2, x, z, 3, 3);
"True coefficients = " 0.2~0.5;
"                    " 0.5~0.1;
"Ahat, FM-GIVE = " ahat;
"Long-Run Covariance Matrix of the parameters " vc;
"long-Run Variance of the residual matrix " lrv;
"s1 = " s1 ;
"s2 = " s2 ;
"st (= s1 + s2)" (s1 + s2);
