new;
library coint, pgraph;
output file=fmgmm.out reset;

seed = 238475;

n = 100;
d = ones(n, 1);

load rn[100,10]=rn.dat;

// Generate random walks
dz = rn[., 5:8];
dx = rn[., 1:2];
e2 = rn[., 3];
e1 = rn[., 4];      

// Accumulate the innovations
x = recserar(dx, 0.0~0.0, 1.0~1.0);

/* 
** x is a non-cointegrated system 
** of 2 I(1) variables             
*/
z = recserar(dz, 0.0~0.0~0.0~0.0, 1.0~1.0~1.0~1.0);

/* develop a cointegrated regression equation */
/* cointegrating vector: (1,-1,-1)            */


_times = 1;
_filter = 0;
_aband = 0;

y1  = 0.2*x[., 1] + 0.5*x[., 2] + e1;
y2  = 0.5*x[., 1] + 0.1*x[., 2] + e2;

_ker_fun = &parzen;

/* Estimate using FM-GMM */

"system of two equations, two explanatory variables";
{ ahat, vc, lrv, s1,s2 } = fm_gmm(y1~y2, x, z, 10);
"True coefficients = " 0.2~0.5;
"                    " 0.5~0.1;
"Ahat, FM-GMM = " ahat;
"Long-Run Co-Variance of the parameters " vc;
"long-Run Co-Variance of the residual matrix " lrv;

"s1 = " s1 ;
"s2 = " s2 ;
"st (= s1 + s2) " (s1+s2);
