new;
library coint, pgraph;
output file=sw.out reset;

// Generate a random walk
seed = 238475;
dx = rndns(100,2,seed);      

// Accumulate the innovations
y  = cumsumc(dx);              
/* 
** y is a non-cointegrated system
** of 2 I(1) variables             
*/
_ker_fun = &parzen;
"Non-cointegrated model.";
{ sw_stat, cvs } = sw(y, -1, 5);

"Stock-Watson statistics";
sw_stat;
"Critical values = " cvs;

// Now develop a cointegrated system
z = y[., 1] + dx[., 2];

/* 
** Z and Y are cointegrated.  
** Should easily reject null of no-coint  
*/

y = z~y[., 1];

" ";
"Cointegrated model";
{ sw_stat, cvs } = sw(y, -1, 5);

"Stock-Watson statistics";
sw_stat;
"Critical values = " cvs;
