/*
** NP data runs for COINT 2.1 
**
** Peter C B Phillips  10/25/2016
**
*/
new;

library coint, pgraph;

pqgwin many;
output reset;
output file = variance.out on;
print;

// set global parameter for choice of error variance estimate
// loop through the 3 setting options for the global _variance
jj = 1;
for jj (1, 3, 1);
if jj == 1;     
    _variance =0;           
    "Error variance estimate global setting: _variance = " _variance;  
    " _variance = 0 delivers: OlS error variance estimate for AIC, BIC, PIC and replicates COINT2.0 "; 
print;    
elseif jj == 2;    
    _variance =1; 
     "Error variance estimate global setting: _variance = " _variance;
    " _variance = 1 delivers: MLE error variance estimate for AIC, BIC, PIC; variance matrix and posterior odds uses OLS error variance estimate "; 
    print;
elseif jj == 3;     
    _variance =2; 
    "Error variance estimate global setting: _variance = " _variance;
    " _variance = 2 delivers: MLE error variance estimate for AIC, BIC, PIC and variance matrix and posterior odds "; 
print; 
endif;

pmax = 9; tmax = 9;        // set maximum orders for lags and trend 
" Maximal orders of lag length  and trend degree p~t = " pmax~tmax;
print; 

fname=__FILE_DIR $+ "np.dat";
load x[111, 15]=^fname; 

for ii (2, cols(x), 1);    // for loop through all 14 series
"Series ii = " ii-1;
xx = x[.,ii];

kj = 0;                     // indicator for number of initializing zeros
kk=1;					    // loop to count zeros
do until kk > rows(xx);
if xx[kk] == 0;
	kj=kj+1;
endif;
  kk=kk+1;
endo;

xx=xx[1+kj:rows(xx)];

"Observation count = " rows(xx);
    
if (ii NE 14) ;
  xx  = ln(xx);            // reset to natural logs
endif;
    
// tn = seqa(1,1,rows(xx)); xy(tn,xx);  // graph series


{zh, lsel, tsel} = arbic(xx, pmax, tmax);   // run arbic
"BIC selected AR order + Trend degree = " lsel~tsel;
{ dep, z, so, bic, postodd, b, ahat, res } = ppadfbit(xx, tsel, lsel);
"b coefficients = " b';
"Long run AR coefficient = " ahat;
"posterior odds for unit root =" 1/postodd;
print;


{ zh, lsel, tsel } = arpic(xx, pmax, tmax);   // run arpic
"PIC selected AR order + Trend degree = " lsel~tsel;
{dep,z,so,bic,postodd,b,ahat,res}= ppadfbit(xx,tsel,lsel);
"b coefficients = " b';
"Long run AR coefficient = " ahat;
"posterior odds for unit root =" 1/postodd;

print;
endfor;
endfor;









